<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 36.50 DataTable Ajax Api</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
    />
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  </head>
  <body>
    <div class="container">
      <h2 style="text-align: center">Danh sách người đăng ký</h2>

      <table
        id="user-table"
        class="table table-bordered table-striped table-hover"
      >
        <thead>
          <tr>
            <th>Mã người dùng</th>
            <th>Firstname</th>
            <th>Lastname</th>
            <th>Country</th>
            <th>Subject</th>
            <th>Customer Type</th>
            <th>Register Status</th>
            <th>Action</th>
          </tr>
        </thead>
        <tbody></tbody>
      </table>
    </div>

    <script>
      $(document).ready(function () {
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

        var gListUsers = [];
        var gNameCol = [
          "id",
          "firstname",
          "lastname",
          "country",
          "subject",
          "customerType",
          "registerStatus",
          "action",
        ];
        const gUSER_ID_COL = 0;
        const gFIRST_NAME_COL = 1;
        const gLAST_NAME_COL = 2;
        const gCOUNTRY_COL = 3;
        const gSUBJECT_COL = 4;
        const gCUSTOMER_TYPE_COL = 5;
        const gREGISTER_STATUS_COL = 6;
        const gACTION_COL = 7;
        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        onPageLoading();

        $(document).on("click", "#user-table .btn-detail", function () {
          onBtnDetailClick(this);
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
          /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
          $("#user-table").DataTable({
            columns: [
              { data: gNameCol[gUSER_ID_COL] },
              { data: gNameCol[gFIRST_NAME_COL] },
              { data: gNameCol[gLAST_NAME_COL] },
              { data: gNameCol[gCOUNTRY_COL] },
              { data: gNameCol[gSUBJECT_COL] },
              { data: gNameCol[gCUSTOMER_TYPE_COL] },
              { data: gNameCol[gREGISTER_STATUS_COL] },
              { data: gNameCol[gACTION_COL] },
            ],
            columnDefs: [
              { targets: gUSER_ID_COL, className: "text-center text-primary" },

              { targets: gCUSTOMER_TYPE_COL, className: "text-center" },
              { targets: gREGISTER_STATUS_COL, className: "text-center" },
              {
                targets: gACTION_COL,
                className: "text-center",
                defaultContent:
                  "<button class='btn btn-primary btn-detail'> Chi tiết </button>",
              },
            ],
          });
          callApiLoadUsers();
        }

        function callApiLoadUsers() {
          $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
            type: "GET",
            dataType: "json",
            success: function (responseObj) {
              console.log(Object.entries(responseObj));
              insertRowToTable(responseObj);
            },
            error: function (error) {
              console.assert(error.responseText);
            },
          });
        }

        function getResponseSuccess(responseObj) {
          console.log(Object.entries(responseObj));
          var vListUser = Object.entries(responseObj);
        }

        function insertRowToTable(paramListUser) {
          "use strict";
          var vTable = $("#user-table").DataTable();
          vTable.clear();
          vTable.rows.add(paramListUser);
          vTable.draw();
        }

        function onBtnDetailClick(paramElement) {
          "use strict";
          var vRowClick = $(paramElement).closest("tr"); //xác định tr chứa nút bấm được click
          var vTable = $("#user-table").DataTable(); //tạo biến truy xuất datatable
          var vDataRow = vTable.row(vRowClick).data(); //lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
          console.log(vDataRow);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      });
    </script>
  </body>
</html>
​
